# -*- python -*-
# $RCSfile: pixelgroupparam.py,v $
# $Revision: 1.10 $
# $Author: reida $
# $Date: 2004/02/13 21:28:29 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 


from common.IO import parameter
from common.IO import selectionplaceholder
import types

# Parameter subclass for choosing a PixelGroup in a Microstructure

class PixelGroupParameter(parameter.StringParameter):
    pass

# Parameter subclass for choosing either a PixelGroup or the currently
# selected pixels.

class PixelAggregateParameter(parameter.ParameterBase):
    def __init__(self, name, value="", default=None, tip=None):
        self.checker = parameter.TypeChecker(
            types.StringType,
            selectionplaceholder.SelectionPlaceHolder,
            selectionplaceholder.AllPlaceHolder)
        parameter.ParameterBase.__init__(self, name, value=value,
                                         default=default, tip=tip)


