# -*- python -*-
# $RCSfile: materialswidget.py,v $
# $Revision: 1.4 $
# $Author: langer $
# $Date: 2004/04/22 20:05:59 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from SWIG.common import switchboard
from common.IO.GUI import parameterwidgets
from common.IO.GUI import chooser
from engine import materialmanager
from engine.IO import materialmenu

class MaterialsWidget(parameterwidgets.ParameterWidget):
    def __init__(self, param, scope=None):
        names = materialmanager.getMaterialNames()
        names.sort()
        self.widget = chooser.ScrolledMultiListWidget(names,
                                                      callback=self.widgetCB)
        parameterwidgets.ParameterWidget.__init__(self, self.widget.gtk, scope)
        self.widget.set_selection(param.value)
        self.sbcallbacks = [
            switchboard.requestCallback('new_material', self.newMaterial),
            switchboard.requestCallback('remove_material', self.newMaterial)
            ]
        self.setValidity(0)             # nothing selected
    def cleanUp(self):
        map(switchboard.removeCallback, self.sbcallbacks)
        parameterwidgets.cleanUp(self)
    def newMaterial(self, *args):
        names = materialmanager.getMaterialNames()
        names.sort()
        self.widget.update(names)
    def get_value(self):
        return self.widget.get_value()
    def set_value(self, value):
        self.widget.set_selection(value)
    def widgetCB(self, list):
        self.setValidity(len(list) > 0)

def _MaterialsWidget_makeWidget(self, scope=None):
    return MaterialsWidget(self, scope)

materialmenu.ListOfMaterialsParameter.makeWidget = _MaterialsWidget_makeWidget
