# This file was created automatically by SWIG.
import cstrainc
from SWIG.engine.IO.propertyoutput import PropertyOutputInitPtr
class POInitGeometricStrainPtr(PropertyOutputInitPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C POInitGeometricStrain instance at %s>" % (self.this,)
class POInitGeometricStrain(POInitGeometricStrainPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(cstrainc.new_POInitGeometricStrain,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: cstrain_.py,v $
# $Revision: 1.2 $
# $Author: langer $
# $Date: 2004/06/04 20:57:28 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from SWIG.engine import fieldindex
from SWIG.engine import symmmatrix
from SWIG.engine.IO import propertyoutput
from common import debug
from common import enum
from common import registeredclass
from common.IO import parameter

class StrainType(registeredclass.RegisteredClass):
    registry = []
    def name(self):
        return self._name
    def iterator(self, planarity):
        return fieldindex.getSymTensorIterator(planarity)
    def newOutputValue(self):
        return symmmatrix.newSymTensorOutputValue()
 
class GeometricStrain(StrainType):
    _name="Geometric"

registeredclass.Registration(
    "Geometric Strain",
    StrainType,
    GeometricStrain,
    ordering=0,
    tip="The symmetric derivative of the displacement field")

class ElasticStrain(StrainType):
    _name="Elastic"

registeredclass.Registration(
    "Elastic Strain",
    StrainType,
    ElasticStrain,
    ordering=1,
    tip="The part of the geometric strain that contributes to stress")

class ThermalStrain(StrainType):
    _name="Thermal"

registeredclass.Registration(
    "Thermal Strain",
    StrainType,
    ThermalStrain,
    ordering=2,
    tip="Strain induced by thermal expansion")

class StrainTypeParameter(parameter.RegisteredParameter):
    def __init__(self, name, value=None, default=None, tip=None):
        parameter.RegisteredParameter.__init__(self, name, StrainType,
                                               value, default, tip)
    def clone(self):
        return StrainTypeParameter(self.name, self.value, self.default,
                                   self.tip)

propertyoutput.SymmMatrix3PropertyOutputRegistration(
    "Strain",
    initializer=POInitGeometricStrain(),
    parameters=StrainTypeParameter("type", default=GeometricStrain()))
