# -*- python -*-
# $RCSfile: thermalexpansion_.py,v $
# $Revision: 1.18 $
# $Author: reida $
# $Date: 2004/08/17 19:38:08 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 


from SWIG.engine import symmmatrix
from common import utils
from common.IO import parameter
from engine import problem
from engine import propertyregistration

PropertyRegistration = propertyregistration.PropertyRegistration

PropertyRegistration(
    'Thermal:ThermalExpansion', ThermalExpansionProp,
    "SWIG.engine.property.thermalexpansion.thermalexpansion",200,
    [symmmatrix.SymmMatrix3Parameter('alpha',
                                     symmmatrix.SymmMatrix3(1., 1., 1.,
                                                            0., 0., 0.)),
     parameter.FloatParameter('t0', 0.0)],
    fields=[problem.Temperature],
    fluxes=[problem.Stress],
    outputs=["Strain"],
    propertyType="ThermalExpansion")

# Property reprs refer to the registered name, not the actual class name.
def _ThermalExpansion___repr__(self):
    return "ThermalExpansion(name='%s', alpha=%s, t0=%s)" % \
           (self.name(), `self.alpha()`, `self.tzero()`)

ThermalExpansionPropPtr.__repr__ = _ThermalExpansion___repr__
